﻿namespace Wzorce
{
    class Log //wzorzec singleton
    {
        private static Log? instancja1 = null;
        private static Log? instancja2 = null;

        private static Log? bieżącaInstancja = null;

        //leniwa inicjacja
        public static Log Instancja
        { 
            get 
            {
                if(bieżącaInstancja == null || bieżącaInstancja == instancja2)
                {
                    if (instancja1 == null) instancja1 = new Log();
                    bieżącaInstancja = instancja1;                    
                }
                else
                {
                    if (instancja2 == null) instancja2 = new Log();
                    bieżącaInstancja = instancja2;
                }
                return bieżącaInstancja;
            } 
        }

        private Log()
        {
            Console.WriteLine("Rejestr zdarzeń został utworzony");
        }

        private List<string> komunikaty = new List<string>();

        public void Dodaj(string komunikat)
        {
            komunikaty.Add(DateTime.Now.ToString() + " " + komunikat);
        }

        private const string nazwaPliku1 = "log1.txt";
        private const string nazwaPliku2 = "log2.txt";

        public void Zapisz()
        {
            if (instancja1 != null) File.WriteAllLines(nazwaPliku1, instancja1.komunikaty);
            if (instancja2 != null) File.WriteAllLines(nazwaPliku2, instancja2.komunikaty);
        }
    }


    internal class Program
    {
        static void Main(string[] args)
        {
            Log.Instancja.Dodaj("Uruchomienie aplikacji");

            new DalekaKlasaGłębokoWBibliotekach().Cośtam();

            Log.Instancja.Dodaj("Zatrzymanie aplikacji");
            Log.Instancja.Zapisz();
        }
    }

    class DalekaKlasaGłębokoWBibliotekach
    {
        public void Cośtam()
        {
            Log.Instancja.Dodaj("Metoda Cośtam w dalekiej klasie");
        }
    }

}
